<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/AVSCommon/Utils/include/AVSCommon/Utils/HTTP2/HTTP2MimeResponseDecoder.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_13e65effb2bde530b17b3d5eefcd0266.html">AVSCommon</a></li><li class="navelem"><a class="el" href="dir_49dd3d9ac5586189aa170bac46425b9c.html">Utils</a></li><li class="navelem"><a class="el" href="dir_957fc395b73dfe8b64ee3f74464f588a.html">include</a></li><li class="navelem"><a class="el" href="dir_ced5fe410515ed61d81f9a22ef3eef03.html">AVSCommon</a></li><li class="navelem"><a class="el" href="dir_ee116be5d1129358ffaec72096859541.html">Utils</a></li><li class="navelem"><a class="el" href="dir_0bf0f45007ff5e6885dc23c0041db988.html">HTTP2</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">HTTP2MimeResponseDecoder.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_h_t_t_p2_mime_response_decoder_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2018-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_AVSCOMMON_UTILS_INCLUDE_AVSCOMMON_UTILS_HTTP2_HTTP2MIMERESPONSEDECODER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_AVSCOMMON_UTILS_INCLUDE_AVSCOMMON_UTILS_HTTP2_HTTP2MIMERESPONSEDECODER_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;MultipartParser/MultipartReader.h&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_h_t_t_p2_mime_response_sink_interface_8h.html">AVSCommon/Utils/HTTP2/HTTP2MimeResponseSinkInterface.h</a>&quot;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_h_t_t_p2_response_sink_interface_8h.html">AVSCommon/Utils/HTTP2/HTTP2ResponseSinkInterface.h</a>&quot;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">namespace </span>avsCommon {</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">namespace </span>utils {</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">namespace </span>http2 {</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html">   35</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html">HTTP2MimeResponseDecoder</a> : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_response_sink_interface.html">HTTP2ResponseSinkInterface</a> {</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html#ae6b3d259626fbcae8014715bee9b27b8">HTTP2MimeResponseDecoder</a>(std::shared_ptr&lt;HTTP2MimeResponseSinkInterface&gt; sink);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html#ab234f5eb447fac3a247b9a32452abc88">~HTTP2MimeResponseDecoder</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html#aa176d9360851ea4bb061def93cc930cf">onReceiveResponseCode</a>(<span class="keywordtype">long</span> responseCode) <span class="keyword">override</span>;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html#a8b644dbd2e08c4da4a3366fb3dd9380c">onReceiveHeaderLine</a>(<span class="keyword">const</span> std::string&amp; line) <span class="keyword">override</span>;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2.html#a39abd31bf23bf92ff2e646bb2f385d95">HTTP2ReceiveDataStatus</a> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html#a1ffaea6f47ec38deb5d876eba8b12fe8">onReceiveData</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* bytes, <span class="keywordtype">size_t</span> size) <span class="keyword">override</span>;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html#af730f2ba7857b53a6c4a9c06095c80b0">onResponseFinished</a>(<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2.html#a31cdf3a4381c8885296ba2097263282e">HTTP2ResponseFinishedStatus</a> status) <span class="keyword">override</span>;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> partBeginCallback(<span class="keyword">const</span> MultipartHeaders&amp; headers, <span class="keywordtype">void</span>* userData);</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> partDataCallback(<span class="keyword">const</span> <span class="keywordtype">char</span>* buffer, <span class="keywordtype">size_t</span> size, <span class="keywordtype">void</span>* userData);</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> partEndCallback(<span class="keywordtype">void</span>* userData);</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    std::shared_ptr&lt;HTTP2MimeResponseSinkInterface&gt; m_sink;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordtype">long</span> m_responseCode;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    MultipartReader m_multipartReader;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2.html#a39abd31bf23bf92ff2e646bb2f385d95">HTTP2ReceiveDataStatus</a> m_lastStatus;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keywordtype">size_t</span> m_index;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordtype">size_t</span> m_leadingCRLFCharsLeftToRemove;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">bool</span> m_boundaryFound;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keywordtype">size_t</span> m_lastSuccessIndex;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;};</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;}  <span class="comment">// namespace http2</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;}  <span class="comment">// namespace utils</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;}  <span class="comment">// namespace avsCommon</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_AVSCOMMON_UTILS_INCLUDE_AVSCOMMON_UTILS_HTTP2_HTTP2MIMERESPONSEDECODER_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder_html_aa176d9360851ea4bb061def93cc930cf"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html#aa176d9360851ea4bb061def93cc930cf">alexaClientSDK::avsCommon::utils::http2::HTTP2MimeResponseDecoder::onReceiveResponseCode</a></div><div class="ttdeci">bool onReceiveResponseCode(long responseCode) override</div><div class="ttdef"><b>Definition:</b> HTTP2MimeResponseDecoder.cpp:69</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html">alexaClientSDK::avsCommon::utils::http2::HTTP2MimeResponseDecoder</a></div><div class="ttdef"><b>Definition:</b> HTTP2MimeResponseDecoder.h:35</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder_html_ab234f5eb447fac3a247b9a32452abc88"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html#ab234f5eb447fac3a247b9a32452abc88">alexaClientSDK::avsCommon::utils::http2::HTTP2MimeResponseDecoder::~HTTP2MimeResponseDecoder</a></div><div class="ttdeci">~HTTP2MimeResponseDecoder()=default</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder_html_a1ffaea6f47ec38deb5d876eba8b12fe8"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html#a1ffaea6f47ec38deb5d876eba8b12fe8">alexaClientSDK::avsCommon::utils::http2::HTTP2MimeResponseDecoder::onReceiveData</a></div><div class="ttdeci">HTTP2ReceiveDataStatus onReceiveData(const char *bytes, size_t size) override</div><div class="ttdef"><b>Definition:</b> HTTP2MimeResponseDecoder.cpp:163</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder_html_af730f2ba7857b53a6c4a9c06095c80b0"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html#af730f2ba7857b53a6c4a9c06095c80b0">alexaClientSDK::avsCommon::utils::http2::HTTP2MimeResponseDecoder::onResponseFinished</a></div><div class="ttdeci">void onResponseFinished(HTTP2ResponseFinishedStatus status) override</div><div class="ttdef"><b>Definition:</b> HTTP2MimeResponseDecoder.cpp:242</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_html_a31cdf3a4381c8885296ba2097263282e"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2.html#a31cdf3a4381c8885296ba2097263282e">alexaClientSDK::avsCommon::utils::http2::HTTP2ResponseFinishedStatus</a></div><div class="ttdeci">HTTP2ResponseFinishedStatus</div><div class="ttdef"><b>Definition:</b> HTTP2ResponseFinishedStatus.h:29</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_response_sink_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_response_sink_interface.html">alexaClientSDK::avsCommon::utils::http2::HTTP2ResponseSinkInterface</a></div><div class="ttdef"><b>Definition:</b> HTTP2ResponseSinkInterface.h:33</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="_h_t_t_p2_mime_response_sink_interface_8h_html"><div class="ttname"><a href="_h_t_t_p2_mime_response_sink_interface_8h.html">HTTP2MimeResponseSinkInterface.h</a></div></div>
<div class="ttc" id="_h_t_t_p2_response_sink_interface_8h_html"><div class="ttname"><a href="_h_t_t_p2_response_sink_interface_8h.html">HTTP2ResponseSinkInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder_html_a8b644dbd2e08c4da4a3366fb3dd9380c"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html#a8b644dbd2e08c4da4a3366fb3dd9380c">alexaClientSDK::avsCommon::utils::http2::HTTP2MimeResponseDecoder::onReceiveHeaderLine</a></div><div class="ttdeci">bool onReceiveHeaderLine(const std::string &amp;line) override</div><div class="ttdef"><b>Definition:</b> HTTP2MimeResponseDecoder.cpp:81</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_html_a39abd31bf23bf92ff2e646bb2f385d95"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2.html#a39abd31bf23bf92ff2e646bb2f385d95">alexaClientSDK::avsCommon::utils::http2::HTTP2ReceiveDataStatus</a></div><div class="ttdeci">HTTP2ReceiveDataStatus</div><div class="ttdef"><b>Definition:</b> HTTP2ReceiveDataStatus.h:28</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder_html_ae6b3d259626fbcae8014715bee9b27b8"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_1_1_h_t_t_p2_mime_response_decoder.html#ae6b3d259626fbcae8014715bee9b27b8">alexaClientSDK::avsCommon::utils::http2::HTTP2MimeResponseDecoder::HTTP2MimeResponseDecoder</a></div><div class="ttdeci">HTTP2MimeResponseDecoder(std::shared_ptr&lt; HTTP2MimeResponseSinkInterface &gt; sink)</div><div class="ttdef"><b>Definition:</b> HTTP2MimeResponseDecoder.cpp:54</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
